//   This software is available only for non-commercial  amateur radio
//   or educational  applications.   ALL  other  uses  are  prohibited.
//   This  software may  be  modified  only  if the  resulting code  be
//   made available  publicly  and the  original  author given  credit.
//   Contact the author for information on commercial licenses.
//   (c) Copyright 2000,  Robert Jeffrey King, WB8WKA.  All rights reserved.

#include <FLUXGATE.H>
#include <LCD.C>
//#include <2402.C>
#include <vector.c>
#include <STDLIB.H>

#fuses XT,NOWDT,NOPROTECT,PUT,BROWNOUT

main() {
	long n, hunds, tens, units;
	long reading, compass1_bearing=0, compass2_bearing=0, compass1_avg=0, compass2_avg=0;
    signed long compass_difference=0;

	//setup_counters(RTCC_INTERNAL,RTCC_DIV_2);
	//setup_port_a(NO_ANALOGS);
	//setup_adc(ADC_CLOCK_INTERNAL);

	lcd_init();

	//init_ext_eeprom();

   output_low(LED_RED);
	lcd_putc("\fReady.1234\n");
	delay_ms(300);
	lcd_putc("Testing Display");
	output_low(LED_GRN);
	delay_ms(300);
	lcd_putc("\fMovers Fluxgate\n");
	delay_ms(300);
	lcd_putc("   Compass");
	output_high(LED_RED);
	delay_ms(300);

	reset_both();						// Rest both compasses

while (TRUE)
	{
	wink_pc_low_both();					// Tell both compasses to fetch reading
	//delay_ms(10);
	//while (!input(VEC1_EOC));
	delay_ms(300);						// Need to fix EOC, just wait this long before

/* get readings for compass 1 */
	set_ss(0);
	reading = get_reading_bcd() & 0x3FF;		// Mask off bits
	set_ss(1);
	hunds = ((reading >> 8) & 0x0F);
	tens = ((reading >> 4) & 0x0F);
	units = (reading & 0x0F);

/* take average of last two readings */
	compass1_bearing = ((100* hunds) + (10 * tens) + units);

    // What if compass1_bearing 359 and compass1_avg is 1?
    // Maybe try this:
    // if reading > 270 then reading = reading -270
    // if reading < 90 then readiing = reading + 90
    // then average together and convert back as follows:
    // if reading < 90 then reading = reading + 270
    // if reading >= 90 then reading = reading -90
    
	compass1_avg = (compass1_bearing + compass1_avg)/2;

/* display instant bearing */
	lcd_putc("\f1:");					// Clear display
	lcd_putc(hunds+0x30);
	lcd_putc(tens+0x30);
	lcd_putc(units+0x30);

/* display avg bearing */
    lcd_putc(" ");
    lcd_putc(0xf6);
    lcd_putc(":");
	lcd_putc((int)(compass1_avg/100)+0x30);
	lcd_putc(((int)(compass1_avg % 100)/10)+0x30);
	lcd_putc((int)(compass1_avg % 10)+0x30);


	/* get readings for compass 2 */
 	set_ss_2(0);
	reading = get_reading_bcd_2() & 0x3FF;		// Mask off bits
	set_ss_2(1);
	hunds = ((reading >> 8) & 0x0F);
	tens = ((reading >> 4) & 0x0F);
	units = (reading & 0x0F);

/* take average of last two readings */
	compass2_bearing = ((100* hunds) + (10 * tens) + units);
	compass2_avg = (compass2_bearing + compass2_avg)/2;

	lcd_putc("\n2:");					// New line
	lcd_putc(hunds+0x30);
	lcd_putc(tens+0x30);
	lcd_putc(units+0x30);

/* display avg bearing */
    lcd_putc(" ");
    lcd_putc(0xf6);
    lcd_putc(":");
	lcd_putc((int)(compass2_avg/100)+0x30);
	lcd_putc(((int)(compass2_avg % 100)/10)+0x30);
	lcd_putc((int)(compass2_avg % 10)+0x30);

/* determine difference in two compass readings */

    compass_difference = LABS(compass1_avg - compass2_avg);

	lcd_putc(" ");                // Difference
	lcd_putc(0xf2);                // Difference
	lcd_putc((int)(compass_difference/100)+0x30);
	lcd_putc(((int)(compass_difference % 100)/10)+0x30);
	lcd_putc((int)(compass_difference % 10)+0x30);

/* Light LED based on difference */

    if (compass_difference < 10)
        {
        output_low(LED_GRN);        // Turn on Green LED
        output_high(LED_RED);
        }
    else if (compass_difference < 20)
        {
        output_low(LED_GRN);
        output_low(LED_RED);
        }
    else
        {
        output_high(LED_GRN);
        output_low(LED_RED);
        }

	}
}
